<template>
  <div>
    <q-table
      ref="table"
      :data="data"
      :columns="columns"
      :filter="filterCustom"
      :visible-columns="visibleColumns"
      :separator="separator"
      :rows-per-page-label="rowsperpagelabel"
      :no-results-label="noresultslabel"
      :no-data-label="nodatalabel"
      :loading="loadingTable"
      :pagination.sync="paginationSync"
      :loading-label="loadingLabel"
      row-key="name"
      dense
      color="primary"
      table-style="material striped"
    >

      <template slot="top-right" slot-scope="props">
        <q-btn
          v-if="fullscreen"
          flat
          round
          dense
          :icon="props.inFullscreen ? 'fullscreen_exit' : 'fullscreen'"
          @click="props.toggleFullscreen"
        />
        <q-btn
          v-if="visibleButtonRegister"
          :to="routeRegister"
          :label="component "
          :title="component "
          color="primary"
          icon="add"
          size="sm"
          @click="clickRegisterFunction"
        />
      </template>

      <template
        v-for="template in templateColumns"
        :slot="'body-cell-' + template.columnName"
        slot-scope="props"
      >
        <q-td
          :width="template.columnName === 'acoes' ? '10rem' : ''"
          :key="template.id"
          :slot="'body-cell-' + template.columnName"
          :props="props"
          :align="'right'"
        >
          <slot :name="template.columnName" :props="props"></slot>
        </q-td>
      </template>
    </q-table>
  </div>
</template>

<script>
import { mapState } from 'vuex'
export default {
  props: {
    templateColumns: {
      required: false
    },
    data: {
      type: Array,
      required: true
    },
    columns: {
      required: true
    },
    visibleColumns: {
      required: true
    },
    loadingTable: {
      required: true
    },
    fullscreen: {
      required: false,
      default: true
    },
    visibleButtonRegister: {
      required: false,
      default: true
    },
    visibleControlColumns: {
      required: false,
      default: true
    },
    routeRegister: {
      required: false,
      default: '/'
    },
    component: {
      required: false
    },
    clickRegister: {
      required: false,
      type: Function
    },
    amountLines: {
      required: false,
      type: Number
    }
  },
  computed: {
    ...mapState('CustomTable', ['filter', 'routerTable'])
  },
  data () {
    return {
      filterCustom: '',
      separator: 'cell',
      rowsperpagelabel: 'Linhas por página',
      noresultslabel: ' Sem resultados para sua pesquisa',
      nodatalabel: 'Sem dados no momento',
      loadingLabel: 'Carregando..',
      paginationSync: {
        page: 1,
        rowsPerPage: 10
      }
    }
  },
  methods: {
    clickRegisterFunction: function () {},
    changedFilter () {
      this.$store.state.CustomTable.filter = this.filterCustom
    }
  },
  watch: {
    watch: {
      loadingTable: function (val) {
        this.loadingTable = val
      }

    }
  },
  mounted () {
    if (this.clickRegister) {
      this.clickRegisterFunction = this.clickRegister
    }
  }
}
</script>

<style>
table tbody tr {
  cursor: pointer;
}

table tbody tr:nth-child(2n) {
  background-color: rgb(231, 231, 231);
}

table tbody tr:nth-child(2n):hover {
  background-color: rgb(196, 196, 196);
}

table tbody tr:nth-child(2n + 1):hover {
  background-color: rgb(196, 196, 196);
}

/* table tbody tr:nth-child(2n+1) {
  background-color: blue;
} */

.q-table th {
  color: rgba(0, 0, 0) !important;
}

/* table .q-btn-inner > i {
    font-size: 1.9em !important;
} */
</style>
